## ceph 14.2.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)

project(ceph CXX C ASM)
set(VERSION 14.2.5)

if(POLICY CMP0028)
  cmake_policy(SET CMP0028 NEW)
endif()
if(POLICY CMP0046)
  cmake_policy(SET CMP0046 NEW)
endif()
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()
if(POLICY CMP0056)
  cmake_policy(SET CMP0056 NEW)
endif()
if(POLICY CMP0065)
  cmake_policy(SET CMP0065 NEW)
endif()
if(POLICY CMP0051)
  cmake_policy(SET CMP0051 NEW)
endif()
if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(LINUX ON)
  FIND_PACKAGE(Threads)
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  set(FREEBSD ON)
  FIND_PACKAGE(Threads)
endif(CMAKE_SYSTEM_NAME MATCHES "Linux")

if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7)
    message(FATAL_ERROR "GCC 7+ required due to C++17 requirements")
  endif()
endif()

option(WITH_CCACHE "Build with ccache.")
if(WITH_CCACHE)
  find_program(CCACHE_FOUND ccache)
  if(CCACHE_FOUND)
    message(STATUS "Building with ccache: ${CCACHE_FOUND}, CCACHE_DIR=$ENV{CCACHE_DIR}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    # ccache does not accelerate link (ld), but let it handle it. by passing it
    # along with cc to python's distutils, we are able to workaround
    # https://bugs.python.org/issue8027.
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  else(CCACHE_FOUND)
    message(FATAL_ERROR "Can't find ccache. Is it installed?")
  endif(CCACHE_FOUND)
endif(WITH_CCACHE)

option(WITH_MANPAGE "Build man pages." ON)
if(WITH_MANPAGE)
  find_program(SPHINX_BUILD
    NAMES sphinx-build sphinx-build-3)
  if(NOT SPHINX_BUILD)
    message(FATAL_ERROR "Can't find sphinx-build.")
  endif(NOT SPHINX_BUILD)
endif(WITH_MANPAGE)

include_directories(
  ${PROJECT_BINARY_DIR}/src/include
  ${PROJECT_SOURCE_DIR}/src)

if(OFED_PREFIX)
  include_directories(SYSTEM ${OFED_PREFIX}/include)
  link_directories(${OFED_PREFIX}/lib)
endif()

if(FREEBSD)
  include_directories(SYSTEM /usr/local/include)
  link_directories(/usr/local/lib)
  list(APPEND CMAKE_REQUIRED_INCLUDES /usr/local/include)
endif(FREEBSD)

#Check Includes
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckFunctionExists)

#put all the libs and binaries in one place
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)


CHECK_FUNCTION_EXISTS(fallocate CEPH_HAVE_FALLOCATE)
CHECK_FUNCTION_EXISTS(posix_fadvise HAVE_POSIX_FADVISE)
CHECK_FUNCTION_EXISTS(posix_fallocate HAVE_POSIX_FALLOCATE)
CHECK_FUNCTION_EXISTS(syncfs HAVE_SYS_SYNCFS)
CHECK_FUNCTION_EXISTS(sync_file_range HAVE_SYNC_FILE_RANGE)
CHECK_FUNCTION_EXISTS(pwritev HAVE_PWRITEV)
CHECK_FUNCTION_EXISTS(splice CEPH_HAVE_SPLICE)
CHECK_FUNCTION_EXISTS(getgrouplist HAVE_GETGROUPLIST)
if(NOT APPLE)
  CHECK_FUNCTION_EXISTS(fdatasync HAVE_FDATASYNC)
endif()
CHECK_FUNCTION_EXISTS(strerror_r HAVE_Strerror_R)
CHECK_FUNCTION_EXISTS(name_to_handle_at HAVE_NAME_TO_HANDLE_AT)
CHECK_FUNCTION_EXISTS(pipe2 HAVE_PIPE2)
CHECK_FUNCTION_EXISTS(accept4 HAVE_ACCEPT4)

include(CMakePushCheckState)
cmake_push_check_state(RESET)
set(CMAKE_REQUIRED_LIBRARIES pthread)
CHECK_FUNCTION_EXISTS(pthread_spin_init HAVE_PTHREAD_SPINLOCK)
CHECK_FUNCTION_EXISTS(pthread_set_name_np HAVE_PTHREAD_SET_NAME_NP)
CHECK_FUNCTION_EXISTS(pthread_get_name_np HAVE_PTHREAD_GET_NAME_NP)
CHECK_FUNCTION_EXISTS(pthread_setname_np HAVE_PTHREAD_SETNAME_NP)
CHECK_FUNCTION_EXISTS(pthread_getname_np HAVE_PTHREAD_GETNAME_NP)
CHECK_FUNCTION_EXISTS(pthread_rwlockattr_setkind_np HAVE_PTHREAD_RWLOCKATTR_SETKIND_NP)
cmake_pop_check_state()

CHECK_FUNCTION_EXISTS(eventfd HAVE_EVENTFD)
CHECK_FUNCTION_EXISTS(getprogname HAVE_GETPROGNAME)

CHECK_INCLUDE_FILES("linux/types.h" HAVE_LINUX_TYPES_H)
CHECK_INCLUDE_FILES("linux/version.h" HAVE_LINUX_VERSION_H)
CHECK_INCLUDE_FILES("arpa/nameser_compat.h" HAVE_ARPA_NAMESER_COMPAT_H)
CHECK_INCLUDE_FILES("sys/mount.h" HAVE_SYS_MOUNT_H)
CHECK_INCLUDE_FILES("sys/param.h" HAVE_SYS_PARAM_H)
CHECK_INCLUDE_FILES("sys/types.h" HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES("sys/vfs.h" HAVE_SYS_VFS_H)
CHECK_INCLUDE_FILES("sys/prctl.h" HAVE_SYS_PRCTL_H)
CHECK_INCLUDE_FILES("execinfo.h" HAVE_EXECINFO_H)
if(LINUX)
  CHECK_INCLUDE_FILES("sched.h" HAVE_SCHED)
endif(LINUX)
CHECK_INCLUDE_FILES("valgrind/helgrind.h" HAVE_VALGRIND_HELGRIND_H)

include(CheckTypeSize)
set(CMAKE_EXTRA_INCLUDE_FILES "linux/types.h")
CHECK_TYPE_SIZE(__be16 __BE16) 
CHECK_TYPE_SIZE(__be32 __BE32) 
CHECK_TYPE_SIZE(__be64 __BE64) 
CHECK_TYPE_SIZE(__le16 __LE16) 
CHECK_TYPE_SIZE(__le32 __LE32) 
CHECK_TYPE_SIZE(__le64 __LE64) 
CHECK_TYPE_SIZE(__u8 __U8) 
CHECK_TYPE_SIZE(__u16 __U16) 
CHECK_TYPE_SIZE(__u32 __U32) 
CHECK_TYPE_SIZE(__u64 __U64) 
CHECK_TYPE_SIZE(__s8 __S8) 
CHECK_TYPE_SIZE(__s16 __S16) 
CHECK_TYPE_SIZE(__s32 __S32) 
CHECK_TYPE_SIZE(__s64 __S64) 
unset(CMAKE_EXTRA_INCLUDE_FILES)

include(CheckSymbolExists)
CHECK_SYMBOL_EXISTS(res_nquery "resolv.h" HAVE_RES_NQUERY)
CHECK_SYMBOL_EXISTS(F_SETPIPE_SZ "linux/fcntl.h" CEPH_HAVE_SETPIPE_SZ)
CHECK_SYMBOL_EXISTS(__func__ "" HAVE_FUNC)
CHECK_SYMBOL_EXISTS(__PRETTY_FUNCTION__ "" HAVE_PRETTY_FUNC)
CHECK_SYMBOL_EXISTS(getentropy "unistd.h" HAVE_GETENTROPY)

include(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("
  #include <string.h>
  int main() { char x = *strerror_r(0, &x, sizeof(x)); return 0; }
  " STRERROR_R_CHAR_P)

include(CheckStructHasMember)
CHECK_STRUCT_HAS_MEMBER("struct stat" st_mtim.tv_nsec sys/stat.h
  HAVE_STAT_ST_MTIM_TV_NSEC LANGUAGE C)
CHECK_STRUCT_HAS_MEMBER("struct stat" st_mtimespec.tv_nsec sys/stat.h
  HAVE_STAT_ST_MTIMESPEC_TV_NSEC LANGUAGE C)

set(CEPH_MAN_DIR "share/man" CACHE STRING "Install location for man pages (relative to prefix).")

option(ENABLE_SHARED "build shared libraries" ON)
if(ENABLE_SHARED)
  set(CEPH_SHARED SHARED)
else(ENABLE_SHARED)
  set(CEPH_SHARED STATIC)
endif(ENABLE_SHARED)
set(CMAKE_POSITION_INDEPENDENT_CODE ${ENABLE_SHARED})

option(WITH_STATIC_LIBSTDCXX "Link against libstdc++ statically" OFF)
if(WITH_STATIC_LIBSTDCXX)
  if(CMAKE_COMPILER_IS_GNUCXX)
    set(static_linker_flags "-static-libstdc++ -static-libgcc")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${static_linker_flags}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${static_linker_flags}")
    unset(static_linker_flags)
    set(GPERFTOOLS_USE_STATIC_LIBS TRUE)
  else()
    message(FATAL_ERROR "Please use GCC to enable WITH_STATIC_LIBSTDCXX")
  endif()
endif()
include(CheckCxxAtomic)
if(NOT HAVE_CXX11_ATOMIC)
  set(CMAKE_CXX_STANDARD_LIBRARIES
    "${CMAKE_CXX_STANDARD_LIBRARIES} ${LIBATOMIC_LINK_FLAGS}")
endif()

option(WITH_RDMA "Enable RDMA in async messenger" ON)
if(WITH_RDMA)
  find_package(verbs REQUIRED)
  set(HAVE_VERBS ${VERBS_FOUND})
  find_package(rdmacm REQUIRED)
  set(HAVE_RDMACM ${RDMACM_FOUND})
  set(HAVE_RDMA TRUE)
endif()

find_package(Backtrace)

# remote block storage
option(WITH_RBD "Remote block storage is here" ON)

if(LINUX)
  find_package(udev REQUIRED)
  set(HAVE_UDEV ${UDEV_FOUND})
  find_package(blkid REQUIRED)
  set(HAVE_BLKID ${BLKID_FOUND})
  if(WITH_RBD)
    find_package(genl REQUIRED)
    set(HAVE_GENL $GENL_FOUND)
  endif()
  find_package(keyutils REQUIRED)
  set(HAVE_KEYUTILS ${KEYUTILS_FOUND})
elseif(FREEBSD)
  set(HAVE_UDEV OFF)
  set(HAVE_LIBAIO OFF)
  set(HAVE_BLKID OFF)
  set(HAVE_GENL OFF)
  set(HAVE_KEYUTILS OFF)
else()
  set(HAVE_UDEV OFF)
  message(STATUS "Not using udev")
  set(HAVE_BLKID OFF)
  message(STATUS "Not using BLKID")
  set(HAVE_GENL OFF)
  message(STATUS "Not using GENL")
endif(LINUX)

option(WITH_OPENLDAP "OPENLDAP is here" ON)
if(WITH_OPENLDAP)
  find_package(OpenLdap REQUIRED)
  set(HAVE_OPENLDAP ${OPENLDAP_FOUND})
endif()

option(WITH_GSSAPI "GSSAPI/KRB5 is here" OFF)
if(WITH_GSSAPI)
  find_package(GSSApi REQUIRED)
  set(HAVE_GSSAPI ${GSSApi_FOUND})
endif()

option(WITH_FUSE "Fuse is here" ON)
if(WITH_FUSE)
  find_package(fuse)
  set(HAVE_LIBFUSE ${FUSE_FOUND})
endif()

option(WITH_XFS "XFS is here" ON)
if(WITH_XFS)
  find_package(xfs)
  set(HAVE_LIBXFS ${XFS_FOUND})
endif()

option(WITH_ZFS "enable LibZFS if found" OFF)
if(WITH_ZFS)
  find_package(zfs)
  set(HAVE_LIBZFS ${ZFS_FOUND})
endif()

option(WITH_BLUESTORE "Bluestore OSD backend" ON)
if(WITH_BLUESTORE)
  if(LINUX)
    find_package(aio)
    set(HAVE_LIBAIO ${AIO_FOUND})
  elseif(FREEBSD)
    # POSIX AIO is integrated into FreeBSD kernel, and exposed by libc.
    set(HAVE_POSIXAIO ON)
  endif()
endif()

option(WITH_SPDK "Enable SPDK" OFF)
if(WITH_SPDK)
  if(NOT WITH_BLUESTORE)
    message(SEND_ERROR "Please enable WITH_BLUESTORE for using SPDK")
  endif()
  include(BuildSPDK)
  build_spdk()
  set(HAVE_SPDK TRUE)
endif(WITH_SPDK)

option(WITH_PMEM "Enable PMEM" OFF)
if(WITH_PMEM)
  set(HAVE_PMEM ON)
  if(NOT WITH_BLUESTORE)
    message(SEND_ERROR "Please enable WITH_BLUESTORE for using PMEM")
  endif()
endif()

if(WITH_BLUESTORE)
  if(NOT AIO_FOUND AND NOT HAVE_POSIXAIO AND NOT WITH_SPDK AND NOT WITH_PMEM)
    message(SEND_ERROR "WITH_BLUESTORE is ON, "
      "but none of the bluestore backends is enabled. "
      "Please install libaio, or enable WITH_SPDK or WITH_PMEM (experimental)")
  endif()
endif()

option(WITH_BLUEFS "libbluefs library" OFF)

option(WITH_QATZIP "Enable QATZIP" OFF)
if(WITH_QATZIP)
  find_package(qatzip REQUIRED)
  set(HAVE_QATZIP ${QATZIP_FOUND})
endif(WITH_QATZIP)

# needs mds and? XXX
option(WITH_LIBCEPHFS "libcephfs client library" ON)

# key-value store
option(WITH_KVS "Key value store is here" ON)

# KERNEL remote block storage
option(WITH_KRBD "Kernel Remote block storage is here" ON)

if(WITH_KRBD AND WITHOUT_RBD)
  message(FATAL_ERROR "Cannot have WITH_KRBD with WITH_RBD.")
endif()
if(LINUX)
  if(WITH_LIBCEPHFS OR WITH_KRBD)
    # keyutils is only used when talking to the Linux Kernel key store 
    find_package(keyutils REQUIRED)
    set(HAVE_KEYUTILS ${KEYUTILS_FOUND})
  endif()
endif()

option(WITH_LEVELDB "LevelDB is here" ON)
if(WITH_LEVELDB)
  if(LEVELDB_PREFIX)
    include_directories(SYSTEM ${LEVELDB_PREFIX}/include)
    link_directories(${LEVELDB_PREFIX}/lib)
  endif()
  find_package(leveldb REQUIRED)
  find_file(HAVE_LEVELDB_FILTER_POLICY leveldb/filter_policy.h PATHS ${LEVELDB_INCLUDE_DIR})
endif(WITH_LEVELDB)

find_package(snappy REQUIRED)

option(WITH_BROTLI "Brotli compression support" OFF)
if(WITH_BROTLI)
  set(HAVE_BROTLI TRUE)
endif()

option(WITH_LZ4 "LZ4 compression support" ON)
if(WITH_LZ4)
  find_package(LZ4 1.7 REQUIRED)
  set(HAVE_LZ4 ${LZ4_FOUND})
endif(WITH_LZ4)

option(WITH_CEPH_DEBUG_MUTEX "Use debug ceph::mutex with lockdep" OFF)

#if allocator is set on command line make sure it matches below strings
set(ALLOCATOR "" CACHE STRING
  "specify memory allocator to use. currently tcmalloc, tcmalloc_minimal, \
jemalloc, and libc is supported. if not specified, will try to find tcmalloc, \
and then jemalloc. If neither of then is found. use the one in libc.")
if(ALLOCATOR)
  if(${ALLOCATOR} MATCHES "tcmalloc(_minimal)?")
    find_package(gperftools REQUIRED)
    set(HAVE_LIBTCMALLOC ON)
  elseif(${ALLOCATOR} STREQUAL "jemalloc")
    find_package(JeMalloc REQUIRED)
    set(HAVE_JEMALLOC 1)
  elseif(NOT ALLOCATOR STREQUAL "libc")
    message(FATAL_ERROR "Unsupported allocator selected: ${ALLOCATOR}")
  endif()
else(ALLOCATOR)
  find_package(gperftools)
  set(HAVE_LIBTCMALLOC ${gperftools_FOUND})
  if(NOT gperftools_FOUND)
    find_package(JeMalloc)
  endif()
  if(gperftools_FOUND)
    set(ALLOCATOR tcmalloc)
  elseif(JeMalloc_FOUND)
    set(ALLOCATOR jemalloc)
  else()
    if(NOT FREEBSD)
      # FreeBSD already has jemalloc as its default allocator
      message(WARNING "tcmalloc and jemalloc not found, falling back to libc")
    endif()
    set(ALLOCATOR "libc")
  endif(gperftools_FOUND)
endif(ALLOCATOR)

if(HAVE_LIBTCMALLOC AND WITH_STATIC_LIBSTDCXX)

=== debian/changelog ===
ceph (14.2.5-3~bpo10+2) buster-backports; urgency=medium

  * [87ab6cd] Move smartmontools to Suggests.
    Version 7 is not yet in backports.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 12 Jan 2020 22:30:28 +0100

ceph (14.2.5-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

  [ James Page ]
  * [2e50d5b] Fix misnamed package Recommends brbd1 -> librbd1
  * [11df8ed] Add missing debhelper misc:Depends for python3-ceph
  * [08c3c8b] Add missing Depends on python3-{distutils,routes} to ceph-mgr-dashboard package

 -- Bernd Zeimetz <bzed@debian.org>  Fri, 10 Jan 2020 13:18:36 +0100

ceph (14.2.5-3) unstable; urgency=medium

  * Uploading to unstable

  * [010db9a] Fix ceph-mgr - indefinite queue growth hangs.
    Applying the backport for the fix
    https://github.com/ceph/ceph/pull/32466
    Thanks to Milan Kupcevic (Closes: #947969)
  * [b01de37] Merge branch 'debian/unstable' into debian/experimental
  * [c8f35e5] Add breaks/replaces for ceph-common - ceph mds.
  * [ee905cb] Revert "Configure gbp for experimental"
    This reverts commit 3bcd5ac5f416b902a868036c243d7f19752c82f8.
  * [6303513] Revert "CI: build in experimental"
    This reverts commit d481122833e611c69c28e2b381e1cc1c8f689385.
  * [f1a9482] Snapshot changelog
  * [6e955c8] Removing automatic Ubuntu header
  * [b90d95a] Mark patch as forwarded

 -- Bernd Zeimetz <bzed@debian.org>  Tue, 07 Jan 2020 20:50:28 +0100

ceph (14.2.5-2) experimental; urgency=medium
  
  * [8c74414] lower --max-parallel for >=16GB
    g++ loves to eat ram
  * [b15dcdd] Build-dep. on python3-dev instead python3-all-dev.
    Thanks to Graham Inggs (Closes: #948021)
  * [d481122] CI: build in experimental
  * [4303a75] 32bit: fix more size_t vs uint64_t issues.
  * [c98ea07] Install bash-completion in /usr again.
    This change went missing somewhere during the import of the
    changes done in Ubuntu between 12.2.11 and 14.2.4.
    Thanks to Andreas Beckmann (Closes: #948165)
  * [c7d90b9] Move manpages to ceph-common again.
    This also went missing during the import.
  * [3e5a680] Use a better way to check if we are on 32bit.
  * [c03cd06] rm d/p/boost-py37-compat.patch.
    Upstream renamed assert.h to ceph_assert.h, so this patch should not be
    necessary anymore.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 05 Jan 2020 00:04:23 +0100

ceph (14.2.5-1) experimental; urgency=medium

  [ Bernd Zeimetz ]
  * [3bcd5ac] Configure gbp for experimental
  * [bd0b051] New upstream version 14.2.5
  * [46cbe61] Merge upstream changes for 14.2.5
  * [4dfd819] Refreshing patches
  * [da26f25] Fix copy&paste errors in build-deps.
  * [7ff43a2] Mark build-deps needed for make check.
    And remove the need to install them.
  * [5ef8ac3] Remove left over patch file
  * [91ab5b9] */lib_tp.so files are not built, don't install them.
  * [44591e4] Don't try to install files we don't build
  * [db0994e] librbd1.symbols: add new symbols.
  * [d53724e] Add install/postinstall files for ceph-mgr-k8sevents
  * [acada37] Add lintian override for .chm file.
    Source and build info is shipped.
  * [bbb0bd6] copy the radosgw init file in override_dh_installinit.
  * [a5958d5] Avoid duplicate files.
    etc/bash_completion.d/ceph was accidentally shipped in ceph-base again.
  * [fbc33a3] Add missing > in Dependency.

 -- Bernd Zeimetz <bzed@debian.org>  Thu, 02 Jan 2020 10:52:50 +0100

ceph (14.2.4-9) unstable; urgency=medium

  * [8c74414] lower --max-parallel for >=16GB
    g++ loves to eat ram
  * [b15dcdd] Build-dep. on python3-dev instead python3-all-dev.
    Thanks to Graham Inggs (Closes: #948021)
  * [c98ea07] Install bash-completion in /usr again.
    This change went missing somewhere during the import of the
    changes done in Ubuntu between 12.2.11 and 14.2.4.
    Thanks to Andreas Beckmann (Closes: #948165)
  * [c7d90b9] Move manpages to ceph-common again.
    This also went missing during the import.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 05 Jan 2020 00:22:21 +0100

ceph (14.2.4-8) unstable; urgency=medium

  * [e187e6a] Use WITH_CCACHE from cmake to build with ccache.
  * [8cbe25e] Hack CMakeCache.txt to disable HAVE_ARM_NEON on armel.
    after trying to patch the various places where HAVE_ARM_NEON is used
    the easiest way to get rid of it on armel seems to be to patch the cmake
    cache file.
  * [424ea9b] Don't build ceph on mipsel.
    No compiler is able to build the code without running into oom-issues.

 -- Bernd Zeimetz <bzed@debian.org>  Wed, 01 Jan 2020 19:29:48 +0100

ceph (14.2.4-7) unstable; urgency=medium

  * [9b97753] Make sure we use ccache if needed.
  * [3dbd1ac] d/rules: Remove the armel fpu options.
    Hopefully properly patched now.
  * [da253e4] m68k, sh4: build with clang to avoid gcc OOM.

 -- Bernd Zeimetz <bzed@debian.org>  Tue, 31 Dec 2019 00:13:23 +0100

ceph (14.2.4-6) unstable; urgency=medium

  * [b1c9b5d] Try to reduce memory usage even further if needed.
    gcc loves to eat too much memory on armhf mipsel armel.
  * [d695778] Remove softfp patch in favour of build flags.
    This hopefully avoids the need to update and debug the patch.
  * [6eddb32] Build with clang(++) on armhf mipsel armel.
    Reports seem to suggest that clang does not need as much memory as gcc.
  * [b9420ba] Fix unsigned/size_t issue for sh4 & m86k.
  * [0027181] Updating changelog
  * [6502f60] Fix another 32bit size_t/uint64_t issue.
    In src/common/options.cc line 192.
  * [4a0b044] Fix another 32bit size_t/uint64_t issue.
    This time: powerpc.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 29 Dec 2019 17:38:10 +0100

ceph (14.2.4-5) unstable; urgency=medium

  [ Bernd Zeimetz ]
  * [453eaa4] Avoid using make -j 32 on powerpc.
    A lot of CPU do not always help.

  [ Milan Kupcevic ]
  * [c6ec924] cherry pick critical bluestore data corruption fix
    (Closes: #947457)

  [ Bernd Zeimetz ]
  * [e88fc21] Set -DWITH_BOOST_CONTEXT=OFF where necessary.


=== debian/control ===
Source: ceph
Section: admin
Priority: optional
Maintainer: Ceph Packaging Team <team+ceph@tracker.debian.org>
Uploaders: James Page <jamespage@debian.org>,
           Gaudenz Steinlin <gaudenz@debian.org>,
           Bernd Zeimetz <bzed@debian.org>
Homepage: http://ceph.com/
Vcs-Git: https://salsa.debian.org/ceph-team/ceph.git
Vcs-Browser: https://salsa.debian.org/ceph-team/ceph
Build-Depends:
 clang [armhf mipsel armel m68k sh4],
 cmake,
 cython,
 cython3,
 debhelper (>= 10~),
 default-jdk,
 dh-exec,
 dh-python,
 dpkg-dev (>= 1.16.1~),
 gperf,
 javahelper,
# Make-Check	jq,
 junit4,
 libaio-dev,
 libbabeltrace-ctf-dev,
 libbabeltrace-dev,
 libblkid-dev (>= 2.17),
 libboost-atomic-dev (>= 1.67.0),
 libboost-chrono-dev (>= 1.67.0),
 libboost-context-dev (>= 1.67.0) [!s390x !mips64el !ia64 !m68k !ppc64 !riscv64 !sh4 !sparc64 !x32],
 libboost-coroutine-dev (>= 1.67.0) [!s390x !mips64el !ia64 !m68k !ppc64 !riscv64 !sh4 !sparc64 !x32],
 libboost-date-time-dev (>= 1.67.0),
 libboost-iostreams-dev (>= 1.67.0),
 libboost-program-options-dev (>= 1.67.0),
 libboost-python-dev (>= 1.67.0),
 libboost-random-dev (>= 1.67.0),
 libboost-regex-dev (>= 1.67.0),
 libboost-system-dev (>= 1.67.0),
 libboost-thread-dev (>= 1.67.0),
 libbz2-dev,
 libcap-ng-dev,
 libcunit1-dev,
 libcurl4-gnutls-dev,
 libedit-dev,
 libexpat1-dev,
 libfuse-dev,
 libgoogle-perftools-dev [i386 amd64 powerpc armhf arm64 ppc64el],
 libibverbs-dev,
 libkeyutils-dev,
 libldap2-dev,
 libleveldb-dev,
 liblz4-dev (>= 0.0~r131),
 libncurses-dev,
 libnss3-dev,
 liboath-dev,
 librdmacm-dev,
 libsnappy-dev,
 libssl-dev,
 libtool,
 libudev-dev,
 libnl-3-dev,
 libnl-genl-3-dev,
 libxml2-dev,
 librabbitmq-dev,
 lsb-release,
 pkg-config,
 python3-dev,
# Make-Check    python3-bcrypt,
 python3-cherrypy3,
# Make-Check    python3-coverage,
# Make-Check    python-jwt,
# Make-Check    python3-nose,
 python3-pecan,
# Make-Check    python3-openssl,
# Make-Check    python3-prettytable,
# Make-Check    python3-requests,
 python3-setuptools,
# Make-Check    python3-six,
 python3-sphinx,
# Make-Check    python3-tox,
# Make-Check    python3-werkzeug,
# Make-Check    socat,
 tox,
# Make-Check    uuid-dev,
 uuid-runtime,
 valgrind [amd64 armhf i386 powerpc],
 virtualenv,
 xfslibs-dev,
# Make-Check    xfsprogs,
# Make-Check    xmlstarlet,
 yasm [amd64],
 zlib1g-dev,
Build-Conflicts:
 libcrypto++-dev,
Standards-Version: 4.2.1

Package: ceph
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-mgr (= ${binary:Version}),
 ceph-mon (= ${binary:Version}),
 ceph-osd (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 ceph-mds (= ${binary:Version}),
Description: distributed storage and file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.

Package: ceph-base
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 binutils,
 ceph-common (= ${binary:Version}),
 cryptsetup-bin | cryptsetup,
 gdisk,
 hdparm | sdparm,
 parted,
 uuid-runtime,
 xfsprogs,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 ceph (<< 10.2.2-0ubuntu2~),
 ceph-common (<< 9.2.0-0~),
 ceph-test (<< 12.2.8+dfsg1-1~),
 python-ceph (<< 0.94.1-1~),
Replaces:
 ceph (<< 12.2.8+dfsg1-1~),
 ceph-common (<< 9.2.0-0~),
 ceph-test (<< 12.2.8+dfsg1-1~),
 python-ceph (<< 0.94.1-1~),
Recommends:
 chrony | time-daemon | ntp,
 ceph-mds (= ${binary:Version}),
 librados2 (= ${binary:Version}),
 librbd1 (= ${binary:Version}),
Suggests:
 logrotate,
 btrfs-tools,
Description: common ceph daemon libraries and management tools
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.

Package: ceph-common
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 librbd1 (= ${binary:Version}),
 python3-cephfs (= ${binary:Version}),
 python3-prettytable,
 python3-rados (= ${binary:Version}),
 python3-rbd (= ${binary:Version}),
 python3-requests,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Conflicts:
 ceph-client-tools,
Breaks:
 ceph (<< 9.2.0-0~),
 ceph-base (<< 12.2.10+dfsg1-1~),
 ceph-fs-common (<< 12.2.10+dfsg1-1~),
 ceph-test (<< 9.2.0-0~),
 librbd1 (<< 0.94.1-1~),
 python-ceph (<< 0.94.1-1~),
 radosgw (<< 12.0.3-0~),
 ceph-mds (<< 14.2.5-3~),
Replaces:
 ceph (<< 9.2.0-0~),
 ceph-client-tools,
 ceph-fs-common (<< 12.2.8+dfsg1-1~),
 ceph-test (<< 9.2.0-1~),
 librbd1 (<< 0.94.1-1~),
 python-ceph (<< 0.94.1-1~),
 radosgw (<< 12.0.3-0~),
 ceph-mds (<< 14.2.5-3~),
Suggests:
 ceph,
 ceph-mds,
Description: common utilities to mount and interact with a ceph storage cluster
 Ceph is a distributed storage and file system designed to provide
 excellent performance, reliability, and scalability.  This is a collection
 of common tools that allow one to interact with and administer a Ceph cluster.

Package: ceph-fuse
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 python3,
Recommends:
 fuse,
Description: FUSE-based client for the Ceph distributed file system
 Ceph is a distributed network file system designed to provide
 excellent performance, reliability, and scalability.  This is a
 FUSE-based client that allows one to mount a Ceph file system without
 root privileges.
 .
 Because the FUSE-based client has certain inherent performance
 limitations, it is recommended that the native Linux kernel client
 be used if possible.  If it is not practical to load a kernel module
 (insufficient privileges, older kernel, etc.), then the FUSE client will
 do.

Package: ceph-mds
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ceph-common,
 ceph-fuse,
 libcephfs2,
Breaks:
 ceph (<< 0.67.3-1),
Replaces:
 ceph (<< 0.67.3-1),
Description: metadata server for the ceph distributed file system
 Ceph is a distributed storage and network file system designed to
 provide excellent performance, reliability, and scalability.
 .
 This package contains the metadata server daemon, which is used to
 create a distributed file system on top of the ceph storage cluster.

Package: ceph-mgr
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-base (= ${binary:Version}),
 python3-bcrypt,
 python3-cherrypy3,
 python3-jwt,
 python3-openssl,
 python3-pecan,
 python3-werkzeug,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Replaces:
 ceph (<< 0.93-417),
Breaks:
 ceph (<< 0.93-417),
Suggests:
 ceph-mgr-dashboard,
 ceph-mgr-diskprediction-cloud,
 ceph-mgr-diskprediction-local,
 ceph-mgr-rook,
 ceph-mgr-ssh,
Description: manager for the ceph distributed file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the manager daemon, which is used to expose high
 level management and monitoring functionality.

Package: ceph-mgr-dashboard
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-bcrypt,
 python3-cherrypy3,
 python3-distutils,
 python3-jwt,
 python3-openssl,
 python3-routes,
 python3-werkzeug,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: dashboard plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package provides a ceph-mgr plugin, providing a web-based
 application to monitor and manage many aspects of a Ceph cluster and
 related components.
 .
 See the Dashboard documentation at http://docs.ceph.com/ for details
 and a detailed feature overview.

Package: ceph-mgr-diskprediction-local
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-numpy,
 python3-scipy,
 python3-sklearn,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: diskprediction-local plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the diskprediction_local plugin for the ceph-mgr
 daemon, which helps predict disk failures.

Package: ceph-mgr-diskprediction-cloud
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: diskprediction-cloud plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the diskprediction_cloud plugin for the ceph-mgr
 daemon, which helps predict disk failures.


Package: ceph-mgr-rook
Architecture: all
Depends: ceph-mgr (>= ${binary:Version}),
         python3-six,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Description: rook plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the rook plugin for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to install and configure ceph using
 Rook.


Package: ceph-mgr-k8sevents
Architecture: all
Depends: ceph-mgr (>= ${binary:Version}),
         python3-kubernetes,
         ${misc:Depends},
         ${python:Depends},
Description: kubernetes events plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the k8sevents plugin, to allow ceph-mgr to send
 ceph related events to the kubernetes events API, and track all events
 that occur within the rook-ceph namespace.



Package: ceph-mgr-ssh
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-six,
 ${misc:Depends},
 ${python3:Depends},
Description: ssh orchestrator plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the SSH plugin for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to perform orchestration functions
 over a standard SSH connection.

Package: ceph-mon
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-base (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Replaces:
 ceph (<< 10.2.2-0ubuntu2~),
Breaks:
 ceph (<< 10.2.2-0ubuntu2~),
Description: monitor server for the ceph storage system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the cluster monitor daemon for the Ceph storage
 system. One or more instances of ceph-mon form a Paxos part-time parliament
 cluster that provides extremely reliable and durable storage of cluster
 membership, configuration, and state.

Package: ceph-osd
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-base (= ${binary:Version}),
 lvm2,
 sudo,
 ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
export DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# support ccache for faster build
# cmake uses /usr/bin/c*
ifeq (yes,$(findstring yes,$(shell test -L /usr/lib/ccache/c++ && test -L /usr/lib/ccache/cc && echo -n yes)))
  extraopts += -DWITH_CCACHE=ON
endif

# try to save even more memory on some architectures
# see #849657 for hints.
ifneq (,$(findstring $(DEB_HOST_ARCH),armhf mipsel armel sh4 m68k))
  export CC=clang
  export CXX=clang++
  extraopts += -DCMAKE_CXX_COMPILER=/usr/bin/clang++
  extraopts += -DCMAKE_C_COMPILER=/usr/bin/clang
else
    # Reduce size of debug symbols to fix FTBFS due to the
    # 2GB/3GB address space limits on 32bit
    ifeq (32,$(DEB_HOST_ARCH_BITS))
        export DEB_CFLAGS_MAINT_APPEND = -g1
        export DEB_CXXFLAGS_MAINT_APPEND = -g1
    endif
endif

ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
   skip_packages = -Nceph -Nceph-base -Nceph-mds -Nceph-mgr -Nceph-mon -Nceph-osd
endif

# minimise needless linking and link to libatomic
# The last is needed because long long atomic operations are not directly
# supported by all processor architectures
export DEB_LDFLAGS_MAINT_APPEND= -Wl,--as-needed -latomic

# Enable hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DESTDIR=$(CURDIR)/debian/tmp

export JAVA_HOME=/usr/lib/jvm/default-java
## Set JAVAC to prevent FTBFS due to incorrect use of 'gcj' if found (see "m4/ac_prog_javac.m4").
export JAVAC=javac

extraopts += -DWITH_OCF=ON -DWITH_NSS=ON -DWITH_PYTHON3=ON -DWITH_DEBUG=ON
extraopts += -DWITH_PYTHON2=OFF -DMGR_PYTHON_VERSION=3
extraopts += -DWITH_CEPHFS_JAVA=ON
extraopts += -DWITH_CEPHFS_SHELL=ON
extraopts += -DWITH_TESTS=OFF
extraopts += -DWITH_SYSTEM_BOOST=ON
extraopts += -DWITH_LTTNG=OFF -DWITH_EMBEDDED=OFF
extraopts += -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib
extraopts += -DWITH_MGR_DASHBOARD_FRONTEND=OFF
extraopts += -DWITH_SYSTEMD=ON -DCEPH_SYSTEMD_ENV_DIR=/etc/default
extraopts += -DCMAKE_INSTALL_SYSCONFDIR=/etc
extraopts += -DCMAKE_INSTALL_SYSTEMD_SERVICEDIR=/lib/systemd/system

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  extraopts += -DBOOST_J=$(NUMJOBS)
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),s390x mips64el ia64 m68k ppc64 riscv64 sh4 sparc64 x32))
  # beast depends on libboost_{context,coroutine} which is not supported on s390x
  extraopts += -DWITH_BOOST_CONTEXT=OFF
else
  extraopts += -DWITH_BOOST_CONTEXT=ON
endif

# Disable SPDK as it generates a build which is no compatible
# with older CPU's which are still supported by Ubuntu.
extraopts += -DWITH_SPDK=OFF

MAX_PARALLEL ?= $(shell ./debian/calc-max-parallel.sh)

%:
	dh $@ --buildsystem=cmake --with javahelper,python3,systemd $(MAX_PARALLEL)

override_dh_auto_configure:
	env | sort
	dh_auto_configure --buildsystem=cmake -- $(extraopts)
# after trying to patch the various places where HAVE_ARM_NEON is used
# the easiest way to get rid of it on armel seems to be to patch the cmake
# cache file.
ifeq ($(DEB_HOST_ARCH),armel)
	sed 's,^HAVE_ARM_NEON.*,HAVE_ARM_NEON:INTERNAL=0,' -i obj-arm-linux-gnueabi/CMakeCache.txt
endif

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake --destdir=$(DESTDIR)
	install -D -m 644 udev/50-rbd.rules $(DESTDIR)/lib/udev/rules.d/50-rbd.rules
	install -D -m 644 src/etc-rbdmap $(DESTDIR)/etc/ceph/rbdmap
	install -D -m 644 etc/sysctl/90-ceph-osd.conf $(DESTDIR)/etc/sysctl.d/30-ceph-osd.conf
	install -D -m 600 sudoers.d/ceph-osd-smartctl $(DESTDIR)/etc/sudoers.d/ceph-osd-smartctl
	# NOTE: ensure that any versioned erasure coding test code is dropped
	#       from the package install - package ships unversioned modules.
	rm -f $(CURDIR)/debian/tmp/usr/lib/*/ceph/erasure-code/libec_*.so.*
	find $(CURDIR)/debian/tmp/usr/lib/*/ceph/erasure-code -type l -delete || :


# doc/changelog is a directory, which confuses dh_installchangelogs
override_dh_installchangelogs:
	dh_installchangelogs --exclude doc/changelog

override_dh_installlogrotate:
	cp src/logrotate.conf debian/ceph-common.logrotate
	dh_installlogrotate -pceph-common


override_dh_installinit:
	cp src/init-radosgw debian/radosgw.init
	dh_installinit --no-start
	dh_installinit -pceph-common --name=rbdmap --no-start
	dh_installinit -pceph-base --name ceph --no-start
	# install the systemd stuff manually since we have funny service names
	# and need to update the paths in all of the files post install
	# systemd:ceph-common
	install -d -m0755 debian/ceph-common/usr/lib/tmpfiles.d
	install -m 0644 -D systemd/ceph.tmpfiles.d debian/ceph-common/usr/lib/tmpfiles.d/ceph.conf
	# NOTE(jamespage): Install previous ceph-mon service from packaging for upgrades
	install -d -m0755 debian/ceph-mon/lib/systemd/system
	install -m0644 debian/lib-systemd/system/ceph-mon.service debian/ceph-mon/lib/systemd/system
	# Ensure Debian/Ubuntu specific systemd units are NOT automatically enabled and started
	# Enable systemd targets only
	dh_systemd_enable -Xceph-mon.service -Xceph-osd.service -X ceph-mds.service
	# Start systemd targets only
	dh_systemd_start --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_systemd_enable:
	# systemd enable done as part of dh_installinit

override_dh_systemd_start:
	# systemd start done as part of dh_installinit

override_dh_makeshlibs:
	# exclude jni libraries in libcephfs-jni to avoid pointless ldconfig
	# calls in maintainer scripts; exclude private erasure-code plugins.
	dh_makeshlibs -V -X/usr/lib/jni -X/usr/lib/$(DEB_HOST_MULTIARCH)/ceph/erasure-code

override_dh_auto_test:
	# do not run tests

override_dh_shlibdeps:
	dh_shlibdeps -a --exclude=erasure-code --exclude=rados-classes --exclude=compressor

override_dh_python3:
	for binding in rados cephfs rbd rgw; do \
		dh_python3 -p python3-$$binding --shebang=/usr/bin/python3;      \
        done
	dh_python3 -p python3-ceph-argparse --shebang=/usr/bin/python3
	dh_python3 -p ceph-common --shebang=/usr/bin/python3
	dh_python3 -p ceph-base --shebang=/usr/bin/python3
	dh_python3 -p ceph-osd --shebang=/usr/bin/python3
	dh_python3 -p ceph-mgr --shebang=/usr/bin/python3
	dh_python3 -p cephfs-shell --shebang=/usr/bin/python3

override_dh_builddeb:
	dh_builddeb ${skip_packages}

override_dh_gencontrol:
	dh_gencontrol ${skip_packages}

## ceph 14.2.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.5.1)
 
 project(ceph CXX C ASM)
-set(VERSION 14.2.5)
+set(VERSION 14.2.6)
 
 if(POLICY CMP0028)
   cmake_policy(SET CMP0028 NEW)

=== debian/changelog ===
ceph (14.2.6-4~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Bernd Zeimetz <bzed@debian.org>  Tue, 21 Jan 2020 12:24:47 +0100

ceph (14.2.6-4) unstable; urgency=high

  * Really uploading to unstable now.

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 18 Jan 2020 19:58:32 +0100

ceph (14.2.6-3) experimental; urgency=high

  * Uploading to unstable, including changes to make ceph
    build on mipsel again (Closes: #948722).
  * [1bac6f0] mgr/dashboard: fix improper URL checking.
    This change disables up-level references beyond the HTTP base directory.
    [CVE-2020-1699]
    Upstream commit 0443e40c11280ba3b7efcba61522afa70c4f8158
    Thanks to Salvatore Bonaccorso (Closes: #949206)
  * [720ce76] Updating changelog (from experimental)

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 18 Jan 2020 19:11:22 +0100

ceph (14.2.6-2) experimental; urgency=medium

  * [fc4df2f] d/rules: make sure mips doesn't match on mipsel/mips64el
  * [3d9ed86] Add patch to disable dencoder build if needed.
  * [ce0c9bb] Don't build ceph-dencoder on mipsel.
    Its a debugging tool and does not build on mipsel due to g++/clang++
    running out of memory.
    Replacing it by a shellscript that prints an error message.
  * [0d83e22] Configure gbp for experimental

 -- Bernd Zeimetz <bzed@debian.org>  Thu, 16 Jan 2020 23:59:37 +0100

ceph (14.2.6-1) unstable; urgency=medium

  [ James Page ]
  * [2e50d5b] Fix misnamed package Recommends brbd1 -> librbd1
  * [11df8ed] Add missing debhelper misc:Depends for python3-ceph
  * [08c3c8b] Add missing Depends on python3-{distutils,routes} to ceph-mgr-dashboard package

  [ Bernd Zeimetz ]
  * [a87f434] Update upstream source from tag 'upstream/14.2.6'
    Update to upstream version '14.2.6'
    with Debian dir f37aa9f99ec09cc88d8e5e468c1f642fa7f77ef1
  * [e91626b] Revert "Fix ceph-mgr - indefinite queue growth hangs"
    This reverts commit 010db9a30458a6417ff667c3c11a3870edb8ee0c.
    Patches were applied upstream for 14.2.6

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 12 Jan 2020 23:13:27 +0100

=== debian/control ===
--- 
+++ 
@@ -400,5 +400,5 @@
 Depends:
  ceph-base (= ${binary:Version}),
  lvm2,
+ smartmontools (>= 7.0),
  sudo,
- ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 # try to save even more memory on some architectures
 # see #849657 for hints.
-ifneq (,$(findstring $(DEB_HOST_ARCH),armhf mipsel armel sh4 m68k))
+ifneq (,$(findstring -$(DEB_HOST_ARCH)-,-armhf- -mipsel- -armel- -sh4- -m68k-))
   export CC=clang
   export CXX=clang++
   extraopts += -DCMAKE_CXX_COMPILER=/usr/bin/clang++
@@ -26,6 +26,11 @@
         export DEB_CFLAGS_MAINT_APPEND = -g1
         export DEB_CXXFLAGS_MAINT_APPEND = -g1
     endif
+endif
+
+# disable ceph-dencoder on mipsel to avoid clang oom
+ifneq (,$(findstring -$(DEB_HOST_ARCH)-,-mipsel-))
+    extraopts += -DDISABLE_DENCODER=1
 endif
 
 ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
@@ -64,7 +69,7 @@
   extraopts += -DBOOST_J=$(NUMJOBS)
 endif
 
-ifneq (,$(findstring $(DEB_HOST_ARCH),s390x mips64el ia64 m68k ppc64 riscv64 sh4 sparc64 x32))
+ifneq (,$(findstring -$(DEB_HOST_ARCH)-,-s390x- -mips64el- -ia64- -m68k- -ppc64- -riscv64- -sh4- -sparc64- -x32-))
   # beast depends on libboost_{context,coroutine} which is not supported on s390x
   extraopts += -DWITH_BOOST_CONTEXT=OFF
 else
@@ -92,6 +97,10 @@
 
 override_dh_auto_install:
 	dh_auto_install --buildsystem=cmake --destdir=$(DESTDIR)
+	if [ ! -f $(DESTDIR)/usr/bin/ceph-dencoder ]; then \
+	    cp debian/workarounds/ceph-dencoder-oom $(DESTDIR)/usr/bin/ceph-dencoder ;\
+	    chmod 755 $(DESTDIR)/usr/bin/ceph-dencoder ;\
+	fi
 	install -D -m 644 udev/50-rbd.rules $(DESTDIR)/lib/udev/rules.d/50-rbd.rules
 	install -D -m 644 src/etc-rbdmap $(DESTDIR)/etc/ceph/rbdmap
 	install -D -m 644 etc/sysctl/90-ceph-osd.conf $(DESTDIR)/etc/sysctl.d/30-ceph-osd.conf
